<template>
  <div>
    <v-card>
      <v-toolbar 
        color="secondary" 
        dark>
        <v-icon>print</v-icon>
        <v-toolbar-title 
          class="ml-0 pl-3">
          <span class="hidden-sm-and-down">Print</span>
        </v-toolbar-title>

        <v-spacer/>


        <span v-if="step < 3">
          <v-btn 
            :disabled="!canGoPrev" 
            round 
            color="primary"
            dark
            @click="goPrev"
          >Prev</v-btn>
          <v-btn 
            :disabled="!canGoNext" 
            round 
            color="primary"
            dark
            @click="goNext"
          >{{ nextLabel }}</v-btn>
        </span>

        <span v-else-if="step == 3">
          <v-btn 
            round 
            color="primary"
            dark
            @click="pauseOrResumeTask"
          >Pause</v-btn>
          <v-btn 
            round 
            color="error"
            dark
            @click="abortTask"
          >Abort</v-btn>
        </span>

      </v-toolbar>


    </v-card>

    <v-stepper v-model="step">
      <v-stepper-header>
        <v-stepper-step 
          key="1-step" 
          :complete="step > 1" 
          step="1">Choose file</v-stepper-step>
        <v-divider/>
        <v-stepper-step 
          key="2-step" 
          :complete="step > 2" 
          step="2">Get ready</v-stepper-step>
        <v-divider/>
        <v-stepper-step 
          key="3-step" 
          :complete="step > 3" 
          step="3">Printing</v-stepper-step>
        <v-divider/>
        <v-stepper-step 
          key="4-step" 
          :complete="step > 4" 
          step="4">Finished</v-stepper-step>
      </v-stepper-header>

      <v-stepper-items>
                
        <v-stepper-content 
          key="1-content" 
          step="1">
          <file-view
            :storage="storage"
            select-file
            back
            @selection-change="selectionChange"
          />
        </v-stepper-content>

        <v-stepper-content 
          key="2-content" 
          step="2">
          <get-ready/>
        </v-stepper-content>

        <v-stepper-content 
          key="3-content" 
          step="3">
          <printing/>
        </v-stepper-content>

      </v-stepper-items>

    </v-stepper>

  </div>
</template>

<script>

import {bus} from '@js/bus'

import FileView from '@components/FileView'
import GetReady from './Steps/GetReady'
import Printing from './Steps/Printing'

export default {

	components: {
		FileView,
		GetReady,
		Printing,
	},
	props: {
		storage: {
			type: String,
			default: 'local'
		},
		fileId: {
			type: [String, Number],
			default: null
		},
	},

	data() {
		return {
			step: 1,
			canGoNext: false,
			canGoPrev: false,
			nextLabel: 'Next',

			directory: {},
			parentId: null,
			selectedFile: null,
		}
	},

	created() {
		this.$wamp.call('task.info')
			.then(result => {
				console.log('task.info:', result)
			})
			.catch(error => {
				console.error('task.info:', error)
			})
	},

	computed: {
		selectedFileId() {
			if(this.fileId !== null)
				return this.fileId
			if(this.selectedFile !== null)
				return this.selectedFile.id
			return null
		}
	},

	methods: {
		selectionChange(items) {
			this.canGoNext = items.length > 0
			this.selectedFile = items[0]
		},

		goPrev() {
			switch(this.step) {
			case 2:
				this.step = 1
				this.nextLabel = 'Next'
				this.canGoPrev = false
				break
			}
		},

		goNext() {
			switch(this.step) {
			case 1:
				this.canGoPrev = true
				this.step = 2
				this.nextLabel = 'Start'
				break
			case 2:
				this.startPrint()
					.then(result => {
						this.step = 3
						bus.$emit('show-popup', {message: 'Task started', color: 'success'})
					})
					.catch(error => {
						console.error('tast start failed:', error)
						bus.$emit('show-popup', {message: 'Failed to start print task', color: 'error'})
					})
				
				break
			}
		},

		startPrint() {
			return this.$wamp.call("task.start", [], {
				type: "print",
				controller: "make-print",
				file_uri: 'file://' + this.storage + '/' + this.selectedFileId
			})
			.then(result => {
				console.log('task.start', result)
			})
			.catch(error => {
				console.error('task.start', error)
			})
		},

		pauseOrResumeTask() {
			console.log('pause/resume')
			/*this.$wamp.call("task.info")
				.then(result => {
					console.log('task.info:', result)
				})
				.catch(error => {
					console.error('task.info:', error)
				})*/
			/*this.$wamp.call("gcode.file.push")
				.then(result => {
					console.log('file.push:', result)
				})
				.catch(error => {
					console.error('file.push:', error)
				})*/
			this.$wamp.call('gcode.file.abort')
				.then(result => {
					console.log('file.abort:', result)
				})
				.catch(error => {
					console.error('file.abort:', error)
				})
		},

		abortTask() {
			console.log('abort')
			this.$wamp.call('task.abort')
				.then(result => {
					console.log('task.abort:', result)
					bus.$emit('show-popup', {message: 'Aborting task', color: 'success'})	
				})
				.catch(error => {
					//console.error('file.info:', error)
					bus.$emit('show-popup', {message: 'Task abort failed', color: 'error'})
				})
			/*var task = {
				type : "print",
				controller: "make-print",
				file_uri: "file://local/1"
				// file://usb/my_usb/
			}

			this.$wamp.call("task.start", [], task)
				.then(result => {
					console.log('task.start:', result)
				})
				.catch(error => {
					console.error('task.start:', error)
				})*/

			/*var fn = '/mnt/projects/Colibri-Embedded/fabui/services/gcode-service/test/data/gcode/print/prusa3d/slic3r/PLA_tr_1.0-v2.1-dummy.gcode'
			this.$wamp.call('gcode.file.load_and_push', [fn])
				.then(result => {
					console.log('file.load:', result)

					this.$wamp.call('gcode.file.info')
						.then(result => {
							console.log('file.info:', result)
						})
						.catch(error => {
							console.error('file.info:', error)
						})

				})
				.catch(error => {
					console.error('file.load:', error)
				})*/
		},
	}

}
</script>